//+------------------------------------------------------------------+
//|                                                      Bar2Csv.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,  "

//------------------------------------------------------------------ IsHummer
bool IsHummer(int i)//     
{
	double Body = MathAbs(Open[i]-Close[i]);
	double ShadowHi = High[i]-MathMax(Open[i],Close[i]);
	double ShadowLo = MathMin(Open[i],Close[i])-Low[i];
	if (
	//1.     
		Trend(i, 5)<0 &&
	//2.       .
		ShadowLo>=2*Body &&
	//3.      .
		ShadowLo>=8*ShadowHi) 
		return(true);
	else return(false);
}
//------------------------------------------------------------------ Trend
double Trend(int i, int nPeriod)//   
{
	double t=iMA(NULL, 0, nPeriod, 0, MODE_LWMA, PRICE_WEIGHTED, i)-
						iMA(NULL, 0, nPeriod, 0, MODE_LWMA, PRICE_WEIGHTED, i+1);
	return(t);
}
//------------------------------------------------------------------ start
int start()
{
	string st;
	string FileName = Symbol()+"_hum.csv";
	int hFile = FileOpen(FileName, FILE_WRITE|FILE_CSV, ';');
	FileSeek(hFile, 0, SEEK_END);
	st = "SL;TP;rez";	FileWrite(hFile, st);	
	
	int i, k, TP, nTP, SL, nSL, rez;
	double OpenPrice;
	bool find;
	//       
	TP=20.0;
	while (TP<200)
	{
		SL = 20.0;
		while (SL<200)
		{
			i=Bars-1; 
			nTP=0; nSL=0;
			while (i>=0)//         
			{
				if (IsHummer(i)) //  
				{	
					FileSeek(hFile, 0, SEEK_END);
					//      
					k=i-1; OpenPrice=Open[k]; find=false;
					while (k>0 && !find) 
					{	
						if (Low[k]<=OpenPrice-SL*Point) { nSL++; find=true; }
						else if (High[k]>=OpenPrice+TP*Point) { nTP++; find=true; }
						k--;
					}
				}
				i--;
			}
			rez = (nTP*TP)-(nSL*SL);//     
			st = SL+";"+TP+";"+rez+";"; FileWrite(hFile, st);	//   
			Comment(st);
			SL = SL+5;
		}
		TP = TP+5;
	}
	FileClose(hFile);	
}

